searchNodes=[{"doc":"","ref":"Rail.html","title":"Rail","type":"module"},{"doc":"Apply a function or pipe to a function call when value is not {:error, _} or :error Examples iex&gt; 1 &gt;&gt;&gt; fn v -&gt; Integer . to_string ( v ) end &quot;1&quot; iex&gt; { :ok , 1 } &gt;&gt;&gt; fn v -&gt; Integer . to_string ( v ) end &quot;1&quot; iex&gt; { :ok , 1 } &gt;&gt;&gt; Integer . to_string ( ) &quot;1&quot; iex&gt; :error &gt;&gt;&gt; Integer . to_string ( ) :error iex&gt; { :error , :div_by_zero } &gt;&gt;&gt; Integer . to_string ( ) { :error , :div_by_zero }","ref":"Rail.html#%3E%3E%3E/2","title":"Rail.>>>/2","type":"macro"},{"doc":"Apply a function when value is not {:error, _} or :error Examples iex&gt; 1 |&gt; Rail . chain ( fn v -&gt; v + 10 end ) 11 iex&gt; { :ok , 1 } |&gt; Rail . chain ( fn v -&gt; v + 10 end ) 11 iex&gt; :error |&gt; Rail . chain ( fn v -&gt; v + 10 end ) :error iex&gt; { :error , :noent } |&gt; Rail . chain ( fn v -&gt; v + 10 end ) { :error , :noent }","ref":"Rail.html#chain/2","title":"Rail.chain/2","type":"function"},{"doc":"Similar to Kernel.def/2 , but the function body is wrapped in a rail/1 block. defmodule Target do use Rail def sum ( ) do x &lt;- { :ok , 1 } y &lt;- { :ok , 1 } { :ok , x + y } end end","ref":"Rail.html#def/2","title":"Rail.def/2","type":"macro"},{"doc":"Similar to Kernel.defp/2 , but the function body is wrapped in a rail/1 block. defmodule Target do use Rail defp sum ( ) do x &lt;- { :ok , 1 } y &lt;- { :ok , 1 } { :ok , x + y } end end","ref":"Rail.html#defp/2","title":"Rail.defp/2","type":"macro"},{"doc":"Apply a function for error of {:error, error}, otherwise bypass Examples iex&gt; :error |&gt; Rail . map_error ( fn :noent -&gt; :not_found end ) :error iex&gt; { :error , :noent } |&gt; Rail . map_error ( fn :noent -&gt; :not_found end ) { :error , :not_found }","ref":"Rail.html#map_error/2","title":"Rail.map_error/2","type":"function"},{"doc":"Apply a function for value of {:ok, value}, otherwise bypass Examples iex&gt; :ok |&gt; Rail . map_ok ( fn 1 -&gt; 10 end ) :ok iex&gt; { :ok , 1 } |&gt; Rail . map_ok ( fn 1 -&gt; 10 end ) { :ok , 10 } iex&gt; { :error , 1 } |&gt; Rail . map_ok ( fn 1 -&gt; 10 end ) { :error , 1 }","ref":"Rail.html#map_ok/2","title":"Rail.map_ok/2","type":"function"},{"doc":"Normalize input to {:ok, value} or {:error, error} Examples iex&gt; :error |&gt; Rail . normalize ( ) { :error , nil } iex&gt; { :error , 1 , 2 } |&gt; Rail . normalize ( ) { :error , { 1 , 2 } } iex&gt; :ok |&gt; Rail . normalize ( ) { :ok , nil } iex&gt; { :ok , 1 , 2 } |&gt; Rail . normalize ( ) { :ok , { 1 , 2 } } iex&gt; { :hello , :world } |&gt; Rail . normalize ( ) { :ok , { :hello , :world } }","ref":"Rail.html#normalize/1","title":"Rail.normalize/1","type":"function"},{"doc":"Introduces new syntax left &lt;- right , which bind value to left when right is {:ok, value} or just value or skips entire code block when right is {:error, _} or :error . Examples iex&gt; rail do ...&gt; x &lt;- { :ok , 1 } ...&gt; y &lt;- { :ok , 2 } ...&gt; ...&gt; x + y ...&gt; end 3","ref":"Rail.html#rail/1","title":"Rail.rail/1","type":"macro"},{"doc":"Similar to Kernel.def/2 , but the function body is wrapped in a rail/1 block. defmodule Target do use Rail rail sum ( ) do x &lt;- { :ok , 1 } y &lt;- { :ok , 1 } { :ok , x + y } end end","ref":"Rail.html#rail/2","title":"Rail.rail/2","type":"macro"},{"doc":"Similar to Kernel.defp/2 , but the function body is wrapped in a rail/1 block. defmodule Target do use Rail rail sum ( ) do x &lt;- { :ok , 1 } y &lt;- { :ok , 1 } { :ok , x + y } end end","ref":"Rail.html#railp/2","title":"Rail.railp/2","type":"macro"},{"doc":"","ref":"Rail.ErrorReporter.html","title":"Rail.ErrorReporter","type":"behaviour"},{"doc":"","ref":"Rail.ErrorReporter.html#c:report_error/2","title":"Rail.ErrorReporter.report_error/2","type":"callback"},{"doc":"Rail is a helper macros for &quot;Railway oriented programming&quot;. It helps you handle error cases at almost no cost with rail , &gt;&gt;&gt; , and def macro. If you are not comfortable with &quot;Railway oriented programming&quot;, see Railway oriented programming","ref":"readme.html","title":"Rail","type":"extras"},{"doc":"def deps do [ { :rail , &quot;~&gt; 1.0.0&quot; } ] end","ref":"readme.html#installation","title":"Rail - Installation","type":"extras"},{"doc":"Basic usage use Rail introduces new syntax left &lt;- right , which bind value to left when right is {:ok, value} or value or skips entire code block when right is {:error, _} or :error . defmodule Target do use Rail def div ( num , denom ) do denom &lt;- check_denom ( denom ) num / denom end def check_denom ( 0 ) do { :error , :div_by_zero } end def check_denom ( n ) do # same with {:ok, n} n end end iex&gt; Calc . div ( 10 , 2 ) 5.0 iex&gt; Calc . div ( 10 , 0 ) { :error , :div_by_zero } rail/1 is available inside other code blocks. iex&gt; rail do ... x &lt;- { :ok , 1 } ... y &lt;- { :ok , 2 } ... ... x + y ... end 3 left &gt;&gt;&gt; right is similar to |&gt; , but applies right function only when left is value or {:ok, value} . support both function and call expression, which makes it compatible with |&gt; . iex&gt; 1 &gt;&gt;&gt; fn v -&gt; Integer . to_string ( v ) end &quot;1&quot; iex&gt; { :ok , 1 } &gt;&gt;&gt; fn v -&gt; Integer . to_string ( v ) end &quot;1&quot; iex&gt; { :ok , 1 } &gt;&gt;&gt; Integer . to_string ( ) &quot;1&quot; iex&gt; { :error , :div_by_zero } &gt;&gt;&gt; Integer . to_string ( ) { :error , :div_by_zero } For more examples, see Rail","ref":"readme.html#usage","title":"Rail - Usage","type":"extras"},{"doc":"MIT","ref":"readme.html#license","title":"Rail - LICENSE","type":"extras"},{"doc":"MIT License Copyright (c) 2022 Jechol Lee Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]